# Excel to Plantuml

Turns Excel spreadsheets into architectural drawings. Experimental at this stage.

How does it work?

You need two things.

1. A spreadsheet with at least two worksheets in it. 1 that lists systems, functions etc.
2. a 


## Installation

Get the repo: 

```
git clone git@code.research.uts.edu.au:eresearch/excel2plantuml.git ~/working
npm install .
```

## Usage

To see usage:

```
> node draw.js -h


 Usage: draw [options] <excel> <datasheet> <interfaces> <outputname>

  Extracts data from a spreadsheet to make architecture (component) diagrams

  Options:

    -V, --version                    output the version number
    -c, --component-template [comp]  EJS template to render components
    -f --output-format [format]      Output format [png|svg] - defaults to png (default: png)
    -h, --help                       output usage information
```

Run on the test spreadsheet:
```
node draw.js test/test-architecture.xlsx "Systems"  "Integrations" eResearch -c defaultComponent.ejs
```

Then:

```
open eResearch.png
```

The test spreadsheet `test/test-architecture.xlsx` has two worksheets - one
modeled on the way we are cataloguing our systems at UTS and one that captures
interactions between them this relates Systems and subsystems. The latter does
have some layout information in it without which the diagram just grows to the
left. Both of these are arbitrary 

The layout is controlled by an EJS template. The idea is that multiple diagrams can be created using more templates.

TODO: 

[ ]  Filter the spreadsheet and only draw part of it.
[ ]  Make more views
[ ]  Get some real data

